# coding: utf-8

"""
Slices Experiment Authority

The Slices Experiment Authority API

The version of the OpenAPI document: 0.1.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from typing import Optional, Set
from typing_extensions import Self


class JsonWebKey(BaseModel):
    """
    Json Web Key.
    """  # noqa: E501

    alg: StrictStr = Field(description="Algorithm")
    crv: Optional[StrictStr] = None
    e: Optional[StrictStr] = None
    key_ops: Optional[List[StrictStr]] = None
    kid: StrictStr = Field(description="Key ID")
    kty: StrictStr = Field(description="Key Type")
    n: Optional[StrictStr] = None
    use: Optional[StrictStr] = None
    x: Optional[StrictStr] = None
    x5c: Optional[List[StrictStr]] = None
    x5t: Optional[StrictStr] = None
    x5t_s256: Optional[StrictStr] = Field(default=None, alias="x5t#S256")
    x5u: Optional[Annotated[str, Field(min_length=1, strict=True)]] = None
    y: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = [
        "alg",
        "crv",
        "e",
        "key_ops",
        "kid",
        "kty",
        "n",
        "use",
        "x",
        "x5c",
        "x5t",
        "x5t#S256",
        "x5u",
        "y",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of JsonWebKey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if crv (nullable) is None
        # and model_fields_set contains the field
        if self.crv is None and "crv" in self.model_fields_set:
            _dict["crv"] = None

        # set to None if e (nullable) is None
        # and model_fields_set contains the field
        if self.e is None and "e" in self.model_fields_set:
            _dict["e"] = None

        # set to None if key_ops (nullable) is None
        # and model_fields_set contains the field
        if self.key_ops is None and "key_ops" in self.model_fields_set:
            _dict["key_ops"] = None

        # set to None if n (nullable) is None
        # and model_fields_set contains the field
        if self.n is None and "n" in self.model_fields_set:
            _dict["n"] = None

        # set to None if use (nullable) is None
        # and model_fields_set contains the field
        if self.use is None and "use" in self.model_fields_set:
            _dict["use"] = None

        # set to None if x (nullable) is None
        # and model_fields_set contains the field
        if self.x is None and "x" in self.model_fields_set:
            _dict["x"] = None

        # set to None if x5c (nullable) is None
        # and model_fields_set contains the field
        if self.x5c is None and "x5c" in self.model_fields_set:
            _dict["x5c"] = None

        # set to None if x5t (nullable) is None
        # and model_fields_set contains the field
        if self.x5t is None and "x5t" in self.model_fields_set:
            _dict["x5t"] = None

        # set to None if x5t_s256 (nullable) is None
        # and model_fields_set contains the field
        if self.x5t_s256 is None and "x5t_s256" in self.model_fields_set:
            _dict["x5t#S256"] = None

        # set to None if x5u (nullable) is None
        # and model_fields_set contains the field
        if self.x5u is None and "x5u" in self.model_fields_set:
            _dict["x5u"] = None

        # set to None if y (nullable) is None
        # and model_fields_set contains the field
        if self.y is None and "y" in self.model_fields_set:
            _dict["y"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of JsonWebKey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "alg": obj.get("alg"),
                "crv": obj.get("crv"),
                "e": obj.get("e"),
                "key_ops": obj.get("key_ops"),
                "kid": obj.get("kid"),
                "kty": obj.get("kty"),
                "n": obj.get("n"),
                "use": obj.get("use"),
                "x": obj.get("x"),
                "x5c": obj.get("x5c"),
                "x5t": obj.get("x5t"),
                "x5t#S256": obj.get("x5t#S256"),
                "x5u": obj.get("x5u"),
                "y": obj.get("y"),
            }
        )
        return _obj
